#include<bits/stdc++.h>
using namespace std;
int main()
{
	int n;
	cin>>n;
	int a[n];
	int i,j;
	int maxa[n+1]={0};
	for(i=0;i<n;i++)
	{
		cin>>a[i];                  
	}
	for(i=n-1;i>=0;i--)
	{
		maxa[i]=max(maxa[i+1],a[i]);
	}       
	bool ok=1;
	for(i=0;i<n;i++)
	{
		if(maxa[i]!=a[i])
		{
			ok=0;
			for(j=n-1;j>i;j--)
			{
				if(a[j]>a[i])
				{
					swap(a[i],a[j]);
					break;
				}
			}
			break;	
		}
	}
	if(ok)
		swap(a[n-1],a[n-2]);
	for(i=0;i<n;i++)
		cout<<a[i]<<" ";
}